/*-------------------------------------------------------------------------
   _divuchar.c - routine for unsigned char (8 bit) division

   Copyright (C) 1999, Jean-Louis Vern <jlvern AT gmail.com>
   Adopted for char (8-bit) and pic16 port by
     - Vangelis Rokas, <vrokas AT otenet.gr> (2004)

   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License 
   along with this library; see the file COPYING. If not, write to the
   Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301, USA.

   As a special exception, if you link this library with other files,
   some of which are compiled with SDCC, to produce an executable,
   this library does not by itself cause the resulting executable to
   be covered by the GNU General Public License. This exception does
   not however invalidate any other reasons why the executable file
   might be covered by the GNU General Public License.
-------------------------------------------------------------------------*/

#include <sdcc-lib.h>

//#define MSB_SET(x)	((x >> (8*sizeof(x)-1)) & 1)
#define MSB_SET(x)	(x & 0x80)

unsigned char
_divuchar (unsigned char a, unsigned char b) _IL_REENTRANT
{
  unsigned char reste = 0;
  unsigned char count = 8;
  char c;

  do
  {
    // reste: a <- 0;
    c = MSB_SET(a);
    a <<= 1;
    reste <<= 1;
    if (c)
      reste |= 1;

    if (reste >= b)
    {
      reste -= b;

      // a <- (result = 1)
      a |= 1;
    }
  }
  while (--count);

  return a;
}
